<template>
	<div id="results" class="wlh-results">
		<div class="wlh-results__sidebar">
			<namespace-filter
				:namespaces="namespaces"
				:namespace-selection="currentNamespaceFilter"
				@update-filters="onUpdateNsFilter"
				@reset-filters="onResetNsFilter"
			/>
		</div>

		<div class="wlh-results__content">
			<header class="wlh-results-header">
				<h2 class="wlh-results-header__title">
					Pages that link to
					<a :href="`https://en.wikipedia.org/wiki/${prefixedPageTitle}`">
						{{ prefixedPageTitle }}
					</a>
				</h2>
				<div class="wlh-results-header__info">
					<p class="wlh-results-header__info__count">
						{{ totalResults }} results
					</p>
					<div>
						<label>
							Sort By:
						</label>
						<cdx-select
							v-model:selected="sortSelection"
							class="wlh-results-header__info__selection"
							:menu-items="sortOptions"
							default-label="Sort by..."
						/>
					</div>
				</div>
			</header>

			<div v-if="pending">
				Loading...
			</div>
			<div v-else>
				<template v-for="( link, index ) in displayedResults" :key="index">
					<link-item
						:title="link.title"
						:size="link.bytes"
						:last-updated="link.last_touched"
						:namespace="getNamespaceName( link.namespace )"
					/>
				</template>
				<pagination
					:total-pages="totalPages"
					:current-page="currentPage"
					:showing-all="showAll"
					@update-page="updateCurrentPage"
					@reset-view="resetView"
				/>
				<p>
					<router-link to="/">
						Go back to the start view
					</router-link>
				</p>
			</div>
		</div>
	</div>
</template>

<script lang="ts">
import { defineComponent, ref, computed, watch } from 'vue';
import { useRoute, useRouter, onBeforeRouteLeave } from 'vue-router';
import { CdxSelect, MenuItemData } from '@wikimedia/codex';
import LinkItem from '../components/LinkItem.vue';
import Pagination from '../components/Pagination.vue';
import NamespaceFilter from '../components/NamespaceFilter.vue';
import { Namespace, Backlink } from '../types';
import { sortByLastTouched, sortByTitleAndNamespace } from '../utils';
const RESULTS_PER_PAGE = 10;

export default defineComponent( {
	name: 'ResultsView',
	components: {
		LinkItem,
		Pagination,
		NamespaceFilter,
		CdxSelect
	},
	props: {
		pageId: {
			type: String,
			required: true
		},
		ns: {
			type: String,
			default: ''
		},
		namespaceFilter: {
			type: String,
			default: ''
		}
	},
	setup( props ) {
		const route = useRoute();
		const router = useRouter();

		// Define reactive data
		const pending = ref( true );
		const backlinks = ref<Backlink[]>( [] );
		const namespaces = ref<Namespace[]>( [] );
		const sortSelection = ref( 'alphabetical' );
		const currentPage = ref( 1 );
		const showAll = ref( false );
		const sortOptions = ref<MenuItemData[]>( [
			{ label: 'Alphabetical', value: 'alphabetical' },
			{ label: 'Last Edited', value: 'last edited' }
		] );

		// Get data from the API
		fetchLinksForPage( props.pageId as string ).then( ( pages ) => {
			backlinks.value = pages;
			pending.value = false;
		} );

		fetchNamespaces().then( ( data ) => {
			const namespaceList = Object.keys( data ).map( ( key ) => data[ key ] );
			namespaces.value = namespaceList;
		} );

		// Computed properties
		const currentNamespaceFilter = computed( () => {
			if ( props.namespaceFilter === '' ) {
				return [];
			}

			// Generate an array of integers from a comma-separated string
			// derived from url query params
			const nsArray = props.namespaceFilter
				.split( ',' )
				.map( ( id ) => Number( id ) );

			// If any values are non-numerical, just return an empty array instead
			return nsArray.includes( NaN ) ?
				[] :
				nsArray;
		} );

		const filteredResults = computed( () => {
			if ( currentNamespaceFilter.value.length === 0 ) {
				return backlinks.value;
			} else {
				return backlinks.value.filter( ( b ) => {
					return currentNamespaceFilter.value.includes( b.namespace );
				} );
			}
		} );

		const totalPages = computed( () => {
			if ( filteredResults.value.length > RESULTS_PER_PAGE ) {
				return Math.ceil( filteredResults.value.length / RESULTS_PER_PAGE );
			} else {
				return 1;
			}
		} );

		const totalResults = computed( () => filteredResults.value.length );

		const displayedResults = computed( () => {
			if ( showAll.value ) {
				return filteredResults.value;
			}
			return filteredResults.value.slice(
				( ( currentPage.value - 1 ) * RESULTS_PER_PAGE ),
				( currentPage.value * RESULTS_PER_PAGE )
			);
		} );

		const prefixedPageTitle = computed( () => {
			const ns = props.ns as string;
			const pagePrefix = getNamespaceName( Number( ns ) || 0 );

			if ( pagePrefix === 'Main' ) {
				return props.pageId;
			} else {
				return `${pagePrefix}:${props.pageId}`;
			}
		} );

		// Various methods
		async function fetchLinksForPage( pageId: string ) {
			const ns = props.ns as string;
			const url = `https://wlh-api.toolforge.org/backlinks?title=${pageId}&ns=${ns || 0}`;
			const response = await fetch( url );
			const data = await response.json();
			const links = data.pages as Backlink[];
			return links;
		}

		async function fetchNamespaces() {
			const endpoint = 'https://en.wikipedia.org/w/api.php';
			const params = '?action=query&format=json&meta=siteinfo&formatversion=2&siprop=namespaces&origin=*';
			const apiUrl = new URL( `${endpoint}${params}` );
			apiUrl.searchParams.set( 'origin', '*' );
			const url = apiUrl.toString();
			const response = await fetch( url );
			const data = await response.json();
			return data.query.namespaces;
		}

		function onUpdateNsFilter( id: number ) {
			let newQueryParam: number[];

			if ( currentNamespaceFilter.value.includes( id ) ) {
				newQueryParam = currentNamespaceFilter.value.filter( ( i ) => i !== id );
			} else {
				// newQueryParam = currentNamespaceFilter.value.push( id );
				newQueryParam = currentNamespaceFilter.value.concat( [ id ] );
			}

			router.push( {
				query: {
					...route.query,
					// eslint-disable-next-line camelcase
					namespace_filter: newQueryParam.join( ',' )
				}
			} );
		}

		function onResetNsFilter() {
			router.push( {
				query: {
					...route.query,
					// eslint-disable-next-line camelcase
					namespace_filter: ''
				}
			} );
		}

		function getNamespaceName( namespaceId: number ) {
			const namespace = namespaces.value.find( ( item ) => item.id === namespaceId );
			return namespace?.name || 'Main';
		}

		function updateCurrentPage( newPage: number ) {
			currentPage.value = newPage;
		}

		function resetView() {
			showAll.value = !showAll.value;
		}

		onBeforeRouteLeave( () => {
			backlinks.value = [];
		} );

		// Return to first page of results if the namespace filter changes
		watch( currentNamespaceFilter, ( newVal ) => {
			if ( newVal !== currentNamespaceFilter.value ) {
				currentPage.value = 1;
			}
		} );

		// respond to changes in sortSelection whenever the user interacts with the dropdown
		// this watcher will modify the original backlinks ref in-place as needed
		// (side effect is expected here)
		watch( sortSelection, ( newValue ) => {
			if ( newValue === 'last edited' ) {
				backlinks.value.sort( sortByLastTouched );
			} else {
				backlinks.value.sort( sortByTitleAndNamespace );
			}
		} );

		return {
			displayedResults,
			sortOptions,
			sortSelection,
			showAll,
			currentPage,
			totalPages,
			totalResults,
			updateCurrentPage,
			resetView,
			namespaces,
			onUpdateNsFilter,
			onResetNsFilter,
			getNamespaceName,
			pending,
			prefixedPageTitle,
			currentNamespaceFilter
		};
	}
} );
</script>

<style lang="less">
@import (reference) '@wikimedia/codex-design-tokens/theme-wikimedia-ui.less';

.wlh-results {
	display: flex;
	align-items: baseline;
	justify-content: space-between;

	&__sidebar {
		flex: 0 1 15rem;
	}

	&__content {
		flex: 1 1 auto;
	}
}

.wlh-results-header {
	&__info {
		display: flex;
		align-items: baseline;
		justify-content: space-between;
	}
}
</style>
